/// <reference types="node" />
import { Debe, IListenerOptions, listenTypes } from 'debe';
import http from 'http';
import { ISocketBase } from 'debe-socket';
import { IAttach } from './types';
export * from './types';
export declare const attach: IAttach;
export declare class SocketServer {
    externalServer: boolean;
    httpServer: http.Server;
    agServer: import("./types").IAGServer;
    db: Debe;
    constructor(db: Debe);
    constructor(db: Debe, port: number);
    constructor(db: Debe, server: http.Server);
    close(): Promise<void>;
    connect(): Promise<void>;
    handleMethods(socket: ISocketBase, method: string): Promise<void>;
    handleSubscriptions(socket: ISocketBase): Promise<void>;
    spawnListener(id: string, action: listenTypes, options: IListenerOptions, socket: ISocketBase): void;
}
