import * as tslib_1 from "tslib";
import http from 'http';
import { allowedMethods } from 'debe-socket';
export var attach = require('asyngular-server').attach;
var SocketServer = (function () {
    function SocketServer(db, arg) {
        this.externalServer = false;
        this.httpServer = http.createServer();
        this.agServer = attach(this.httpServer);
        if (!arg) {
            arg = 8000;
        }
        if (typeof arg === 'number') {
            this.httpServer.listen(arg);
        }
        else {
            this.httpServer = arg;
            this.agServer = attach(this.httpServer);
            this.externalServer = true;
        }
        this.db = db;
        this.connect();
    }
    SocketServer.prototype.close = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.agServer.close()];
                    case 1:
                        _a.sent();
                        if (!this.externalServer) {
                            this.httpServer.close();
                        }
                        return [2];
                }
            });
        });
    };
    SocketServer.prototype.connect = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var e_1, _a, _b, _c, socket, e_1_1;
            var _this = this;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 11]);
                        _b = tslib_1.__asyncValues(this.agServer.listener('connection'));
                        _d.label = 1;
                    case 1: return [4, _b.next()];
                    case 2:
                        if (!(_c = _d.sent(), !_c.done)) return [3, 4];
                        socket = _c.value.socket;
                        allowedMethods.forEach(function (method) { return _this.handleMethods(socket, method); });
                        this.handleSubscriptions(socket);
                        _d.label = 3;
                    case 3: return [3, 1];
                    case 4: return [3, 11];
                    case 5:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3, 11];
                    case 6:
                        _d.trys.push([6, , 9, 10]);
                        if (!(_c && !_c.done && (_a = _b.return))) return [3, 8];
                        return [4, _a.call(_b)];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8: return [3, 10];
                    case 9:
                        if (e_1) throw e_1.error;
                        return [7];
                    case 10: return [7];
                    case 11: return [2];
                }
            });
        });
    };
    SocketServer.prototype.handleMethods = function (socket, method) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var e_2, _a, _b, _c, req, e_2_1;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 11]);
                        _b = tslib_1.__asyncValues(socket.procedure(method));
                        _d.label = 1;
                    case 1: return [4, _b.next()];
                    case 2:
                        if (!(_c = _d.sent(), !_c.done)) return [3, 4];
                        req = _c.value;
                        this.db[method](req.data[0], req.data[1])
                            .then(function (result) {
                            req.end(result);
                        })
                            .catch(function (err) { return req.error(err); });
                        _d.label = 3;
                    case 3: return [3, 1];
                    case 4: return [3, 11];
                    case 5:
                        e_2_1 = _d.sent();
                        e_2 = { error: e_2_1 };
                        return [3, 11];
                    case 6:
                        _d.trys.push([6, , 9, 10]);
                        if (!(_c && !_c.done && (_a = _b.return))) return [3, 8];
                        return [4, _a.call(_b)];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8: return [3, 10];
                    case 9:
                        if (e_2) throw e_2.error;
                        return [7];
                    case 10: return [7];
                    case 11: return [2];
                }
            });
        });
    };
    SocketServer.prototype.handleSubscriptions = function (socket) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var e_3, _a, _b, _c, d, _d, id, action, options, e_3_1;
            return tslib_1.__generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 5, 6, 11]);
                        _b = tslib_1.__asyncValues(socket.receiver('subscribe'));
                        _e.label = 1;
                    case 1: return [4, _b.next()];
                    case 2:
                        if (!(_c = _e.sent(), !_c.done)) return [3, 4];
                        d = _c.value;
                        _d = tslib_1.__read(d, 3), id = _d[0], action = _d[1], options = _d[2];
                        this.spawnListener(id, action, options, socket);
                        _e.label = 3;
                    case 3: return [3, 1];
                    case 4: return [3, 11];
                    case 5:
                        e_3_1 = _e.sent();
                        e_3 = { error: e_3_1 };
                        return [3, 11];
                    case 6:
                        _e.trys.push([6, , 9, 10]);
                        if (!(_c && !_c.done && (_a = _b.return))) return [3, 8];
                        return [4, _a.call(_b)];
                    case 7:
                        _e.sent();
                        _e.label = 8;
                    case 8: return [3, 10];
                    case 9:
                        if (e_3) throw e_3.error;
                        return [7];
                    case 10: return [7];
                    case 11: return [2];
                }
            });
        });
    };
    SocketServer.prototype.spawnListener = function (id, action, options, socket) {
        var handleSub = function (error, data) {
            socket.transmit(id, [error ? error.message : undefined, data]);
        };
        this.db.dispatcher.listen(action, handleSub, options);
    };
    return SocketServer;
}());
export { SocketServer };
//# sourceMappingURL=index.js.map